//+------------------------------------------------------------------+
//|                                          Relativ Vigor Index.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Green
#property  indicator_color2  Red
//---- indicator parameters
extern int JurX_Length  = 5; //  JurX  
/*  ,      
(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED,
7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW, 
11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 
14-Heiken Ashi Close.) */
extern int Input_Price_Customs = 0;
//---- indicator buffers
double     ExtRVIBuffer[];
double     ExtRVISignalBuffer[];

double Price,JurX,JJurX,Error;

#include <JurXSeries.mqh> 
#include <PriceSeries.mqh>
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
    // indicator buffers mapping
    SetIndexBuffer(0, ExtRVIBuffer);
    SetIndexBuffer(1, ExtRVISignalBuffer);
    
    // indicator line
    SetIndexStyle(0, DRAW_LINE);
    SetIndexStyle(1, DRAW_LINE);
    
    // drawing settings   
    SetIndexDrawBegin(0, JurX_Length);   
    SetIndexDrawBegin(1, JurX_Length);     
    
    // name for DataWindow and indicator subwindow label
    IndicatorShortName("RVI(" + JurX_Length + ")");
    SetIndexLabel(0, "RVI");
    SetIndexLabel(1, "RVIS");
    
    if(JurXSeriesResize(2) != 2) return(-1);
    JurXSeriesAlert(0, "JurX_Length", JurX_Length); 
    PriceSeriesAlert(Input_Price_Customs);
    
    return(0);
}
//+------------------------------------------------------------------+
//| Relativ Vigor Index                                              |
//+------------------------------------------------------------------+
int start()
{
    if(Bars - 1 < JurX_Length + 32) return(0);
    
    int reset, MaxBar, limit, counted_bars = IndicatorCounted();
    
    if(counted_bars < 0) return(-1);
    if(counted_bars > 0) counted_bars--;
    limit = Bars - counted_bars - 1; 
    MaxBar = Bars - 1;  
    //+---------------------------------------------------- Main processing ----+  
    for(int bar = limit; bar >= 0; bar--)
    {
        Price = (Close[bar] - Open[bar]) / (High[bar] - Low[bar]);
        //JurX = JurXSeries(0, 0, MaxBar, limit, JurX_Length, Price, bar, reset); 
        //if(reset != 0) return(-1); 
        //Error = JurXSeries(1, 0, MaxBar, limit, JurX_Length, 100, bar, reset); 
        //if(reset != 0) return(-1);
        //if(Error == 0) Error = 100;
        //JurX *= 100 / Error;
        ExtRVIBuffer[bar] = JJurX;     
    }
      
    return(0);
}